from robot import *
import argparse
import logging
import time

parser = argparse.ArgumentParser()
parser.add_argument('--host', default='localhost', help='name of host to connect to (localhost)')
parser.add_argument('--port', type=int, default=30001, help='port number (30001)')
parser.add_argument('--samples', type=int, default=100, help='number of samples to record')

args = parser.parse_args()

robot = Robot('RobotStateMessage.xlsx', 'v2.1.0')
robot.connect(args.host, args.port)

sample_count = args.samples

while sample_count > 0:
    data = robot.get_data()
    if data == None:
        logging.warning("Data is None")
        continue
    print("actual_joint : ")
    print(data.actual_joint0, end=' ')
    print(data.actual_joint1, end=' ')
    print(data.actual_joint2, end=' ')
    print(data.actual_joint3, end=' ')
    print(data.actual_joint4, end=' ')
    print(data.actual_joint5)
    sample_count -= 1
    time.sleep(0.1)
    
    
    