import sys
sys.path.append('../rtsi/')
from rtsi import rtsi
import time
import argparse

parser = argparse.ArgumentParser()
parser.add_argument('--host', default='localhost', help='ip of host to connect to')
args = parser.parse_args()

rt = rtsi(args.host) # 创建rtsi类
rt.connect() # socket链接远程rtsi
rt.version_check() # rtsi版本协议检查
version = rt.controller_version() # 获取控制器协议版本


output1 = rt.output_subscribe('target_speed_fraction,actual_joint_positions',125) # 输出订阅,配方1
output2 = rt.output_subscribe('payload_mass,payload_cog',10) # 输出订阅,配方2


input1 = rt.input_subscribe('speed_slider_mask,speed_slider_fraction') #输入订阅,配方1
input2 = rt.input_subscribe('standard_digital_output_mask,standard_digital_output') #输入订阅,配方2

rt.start() # rtsi 开始


for i in range(0x80 + 1):
    input1.speed_slider_mask = 1
    input1.speed_slider_fraction = float(i) / float(0x80 + 1)
    print(input1.speed_slider_fraction)
    input2.standard_digital_output_mask = 0xffff
    input2.standard_digital_output = i
    rt.set_input(input1)
    rt.set_input(input2)
    time.sleep(1)
    recv_out = rt.get_output_data()
    if recv_out == None:
        continue
    if recv_out.recipe_id == output1.id:
        print("Recipe output1 ID: %d" % recv_out.recipe_id)
        print("target_speed_fraction %f : " % recv_out.target_speed_fraction)
        print("actual_joint_positions : ", end="")
        print(recv_out.actual_joint_positions)
    elif recv_out.recipe_id == output2.id:
        print("Recipe output2 ID: %d" % recv_out.recipe_id)
        print("payload_mass %f : " % recv_out.payload_mass)
        print("payload_cog : ", end="")
        print(recv_out.payload_cog)

rt.disconnect()