import sys
sys.path.append('../rtsi')
from rtsi import rtsi
import argparse
from record import record
from record import CSVRecord

parser = argparse.ArgumentParser()
parser.add_argument('--host', default='localhost', help='ip of host to connect to')
parser.add_argument('--sample', type= int,default=0, help='sample count')
parser.add_argument('--config', default="record_configuration.xml", help='configure file')
parser.add_argument('--out', default="data.csv", help='outfile')
args = parser.parse_args()

conf = record(args.config)

rt = rtsi(args.host) 
rt.connect()
rt.version_check()
output = rt.output_subscribe(','.join(conf.get_recipe('out')[0]),125)
rt.start()

sample_count = args.sample

if sample_count <= 0:
    sample_forever = True
else:
    sample_forever = False

csv = CSVRecord(args.out, conf)
csv.writeheader()
count = 0
while True:
    if sample_count <= 0 and sample_forever == False:
        break
    recv_out = rt.get_output_data_buffered()
    if recv_out == None:
        continue
    csv.writerow(recv_out)
    count += 1
    if sample_count > 0:
        sample_count -= 1
    print("Rtsi recive count %d" % count)