import sys
sys.path.append('../rtsi/')
from rtsi import rtsi
import time
import argparse

parser = argparse.ArgumentParser()
parser.add_argument('--host', default='localhost', help='ip of host to connect to')
args = parser.parse_args()


rt = rtsi(args.host) # 创建rtsi类
rt.connect() # socket链接远程rtsi
rt.version_check() # rtsi版本协议检查
version = rt.controller_version() # 获取控制器协议版本

output = rt.output_subscribe('target_speed_fraction,actual_joint_torques',125) # 输出订阅
input = rt.input_subscribe('speed_slider_mask,speed_slider_fraction') #输入订阅

rt.start() # rtsi 开始

recv_count = 0
while recv_count <= 10:
    #获取输出订阅的数据
    recv_out = rt.get_output_data() # 接收最后一个数据
    if recv_out == None:
        continue
    print(recv_out.target_speed_fraction)
    print(recv_out.actual_joint_torques)
    #设置输入订阅项
    input.speed_slider_mask = 1
    input.speed_slider_fraction = recv_out.target_speed_fraction + 0.01
    rt.set_input(input)
    recv_count += 1
    #time.sleep(1)

# rtsi 暂停
rt.pause()
# 断开与 rtsi 远程链接
rt.disconnect()